<?xml version="1.0" encoding="ascii"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
          "DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
  <title>pyxmpp.sasl</title>
  <link rel="stylesheet" href="epydoc.css" type="text/css" />
  <script type="text/javascript" src="epydoc.js"></script>
</head>

<body bgcolor="white" text="black" link="blue" vlink="#204080"
      alink="#204080">
<!-- ==================== NAVIGATION BAR ==================== -->
<table class="navbar" border="0" width="100%" cellpadding="0"
       bgcolor="#a0c0ff" cellspacing="0">
  <tr valign="middle">
  <!-- Home link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="pyxmpp-module.html">Home</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Tree link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="module-tree.html">Trees</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Index link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="identifier-index.html">Indices</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Help link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="help.html">Help</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Project homepage -->
      <th class="navbar" align="right" width="100%">
        <table border="0" cellpadding="0" cellspacing="0">
          <tr><th class="navbar" align="center"
            ><a class="navbar" target="_top" href="http://pyxmpp.jajcus.net/">PyXMPP</a></th>
          </tr></table></th>
  </tr>
</table>
<table width="100%" cellpadding="0" cellspacing="0">
  <tr valign="top">
    <td width="100%">
      <span class="breadcrumbs">
        <a href="pyxmpp-module.html">Package&nbsp;pyxmpp</a> ::
        Package&nbsp;sasl
      </span>
    </td>
    <td>
      <table cellpadding="0" cellspacing="0">
        <!-- hide/show private -->
        <tr><td align="right"><span class="options">[<a href="javascript:void(0);" class="privatelink"
    onclick="toggle_private();">hide&nbsp;private</a>]</span></td></tr>
      </table>
    </td>
  </tr>
</table>
<h1 class="epydoc">Source Code for <a href="pyxmpp.sasl-module.html">Package pyxmpp.sasl</a></h1>
<pre class="py-src">
<a name="L1"></a><tt class="py-lineno"> 1</tt>  <tt class="py-line"><tt class="py-comment">#</tt> </tt>
<a name="L2"></a><tt class="py-lineno"> 2</tt>  <tt class="py-line"><tt class="py-comment"># (C) Copyright 2003-2010 Jacek Konieczny &lt;jajcus@jajcus.net&gt;</tt> </tt>
<a name="L3"></a><tt class="py-lineno"> 3</tt>  <tt class="py-line"><tt class="py-comment">#</tt> </tt>
<a name="L4"></a><tt class="py-lineno"> 4</tt>  <tt class="py-line"><tt class="py-comment"># This program is free software; you can redistribute it and/or modify</tt> </tt>
<a name="L5"></a><tt class="py-lineno"> 5</tt>  <tt class="py-line"><tt class="py-comment"># it under the terms of the GNU Lesser General Public License Version</tt> </tt>
<a name="L6"></a><tt class="py-lineno"> 6</tt>  <tt class="py-line"><tt class="py-comment"># 2.1 as published by the Free Software Foundation.</tt> </tt>
<a name="L7"></a><tt class="py-lineno"> 7</tt>  <tt class="py-line"><tt class="py-comment">#</tt> </tt>
<a name="L8"></a><tt class="py-lineno"> 8</tt>  <tt class="py-line"><tt class="py-comment"># This program is distributed in the hope that it will be useful,</tt> </tt>
<a name="L9"></a><tt class="py-lineno"> 9</tt>  <tt class="py-line"><tt class="py-comment"># but WITHOUT ANY WARRANTY; without even the implied warranty of</tt> </tt>
<a name="L10"></a><tt class="py-lineno">10</tt>  <tt class="py-line"><tt class="py-comment"># MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</tt> </tt>
<a name="L11"></a><tt class="py-lineno">11</tt>  <tt class="py-line"><tt class="py-comment"># GNU Lesser General Public License for more details.</tt> </tt>
<a name="L12"></a><tt class="py-lineno">12</tt>  <tt class="py-line"><tt class="py-comment">#</tt> </tt>
<a name="L13"></a><tt class="py-lineno">13</tt>  <tt class="py-line"><tt class="py-comment"># You should have received a copy of the GNU Lesser General Public</tt> </tt>
<a name="L14"></a><tt class="py-lineno">14</tt>  <tt class="py-line"><tt class="py-comment"># License along with this program; if not, write to the Free Software</tt> </tt>
<a name="L15"></a><tt class="py-lineno">15</tt>  <tt class="py-line"><tt class="py-comment"># Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.</tt> </tt>
<a name="L16"></a><tt class="py-lineno">16</tt>  <tt class="py-line"><tt class="py-comment">#</tt> </tt>
<a name="L17"></a><tt class="py-lineno">17</tt>  <tt class="py-line"><tt class="py-docstring">"""SASL authentication implementaion for PyXMPP.</tt> </tt>
<a name="L18"></a><tt class="py-lineno">18</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L19"></a><tt class="py-lineno">19</tt>  <tt class="py-line"><tt class="py-docstring">Normative reference:</tt> </tt>
<a name="L20"></a><tt class="py-lineno">20</tt>  <tt class="py-line"><tt class="py-docstring">  - `RFC 2222 &lt;http://www.ietf.org/rfc/rfc2222.txt&gt;`__</tt> </tt>
<a name="L21"></a><tt class="py-lineno">21</tt>  <tt class="py-line"><tt class="py-docstring">"""</tt> </tt>
<a name="L22"></a><tt class="py-lineno">22</tt>  <tt class="py-line"> </tt>
<a name="L23"></a><tt class="py-lineno">23</tt>  <tt class="py-line"><tt class="py-name">__docformat__</tt><tt class="py-op">=</tt><tt class="py-string">"restructuredtext en"</tt> </tt>
<a name="L24"></a><tt class="py-lineno">24</tt>  <tt class="py-line"> </tt>
<a name="L25"></a><tt class="py-lineno">25</tt>  <tt class="py-line"><tt class="py-keyword">import</tt> <tt class="py-name">random</tt> </tt>
<a name="L26"></a><tt class="py-lineno">26</tt>  <tt class="py-line"> </tt>
<a name="L27"></a><tt class="py-lineno">27</tt>  <tt class="py-line"><tt class="py-keyword">from</tt> <tt id="link-0" class="py-name" targets="Package pyxmpp=pyxmpp-module.html"><a title="pyxmpp" class="py-name" href="#" onclick="return doclink('link-0', 'pyxmpp', 'link-0');">pyxmpp</a></tt><tt class="py-op">.</tt><tt id="link-1" class="py-name" targets="Package pyxmpp.sasl=pyxmpp.sasl-module.html"><a title="pyxmpp.sasl" class="py-name" href="#" onclick="return doclink('link-1', 'sasl', 'link-1');">sasl</a></tt><tt class="py-op">.</tt><tt id="link-2" class="py-name" targets="Module pyxmpp.sasl.core=pyxmpp.sasl.core-module.html"><a title="pyxmpp.sasl.core" class="py-name" href="#" onclick="return doclink('link-2', 'core', 'link-2');">core</a></tt> <tt class="py-keyword">import</tt> <tt id="link-3" class="py-name" targets="Class pyxmpp.sasl.core.Reply=pyxmpp.sasl.core.Reply-class.html"><a title="pyxmpp.sasl.core.Reply" class="py-name" href="#" onclick="return doclink('link-3', 'Reply', 'link-3');">Reply</a></tt><tt class="py-op">,</tt><tt id="link-4" class="py-name" targets="Class pyxmpp.sasl.core.Response=pyxmpp.sasl.core.Response-class.html"><a title="pyxmpp.sasl.core.Response" class="py-name" href="#" onclick="return doclink('link-4', 'Response', 'link-4');">Response</a></tt><tt class="py-op">,</tt><tt id="link-5" class="py-name" targets="Class pyxmpp.sasl.core.Challenge=pyxmpp.sasl.core.Challenge-class.html"><a title="pyxmpp.sasl.core.Challenge" class="py-name" href="#" onclick="return doclink('link-5', 'Challenge', 'link-5');">Challenge</a></tt><tt class="py-op">,</tt><tt id="link-6" class="py-name" targets="Class pyxmpp.sasl.core.Success=pyxmpp.sasl.core.Success-class.html"><a title="pyxmpp.sasl.core.Success" class="py-name" href="#" onclick="return doclink('link-6', 'Success', 'link-6');">Success</a></tt><tt class="py-op">,</tt><tt id="link-7" class="py-name" targets="Class pyxmpp.sasl.core.Failure=pyxmpp.sasl.core.Failure-class.html"><a title="pyxmpp.sasl.core.Failure" class="py-name" href="#" onclick="return doclink('link-7', 'Failure', 'link-7');">Failure</a></tt><tt class="py-op">,</tt><tt id="link-8" class="py-name" targets="Class pyxmpp.sasl.core.PasswordManager=pyxmpp.sasl.core.PasswordManager-class.html"><a title="pyxmpp.sasl.core.PasswordManager" class="py-name" href="#" onclick="return doclink('link-8', 'PasswordManager', 'link-8');">PasswordManager</a></tt> </tt>
<a name="L28"></a><tt class="py-lineno">28</tt>  <tt class="py-line"> </tt>
<a name="L29"></a><tt class="py-lineno">29</tt>  <tt class="py-line"><tt class="py-keyword">from</tt> <tt id="link-9" class="py-name"><a title="pyxmpp" class="py-name" href="#" onclick="return doclink('link-9', 'pyxmpp', 'link-0');">pyxmpp</a></tt><tt class="py-op">.</tt><tt id="link-10" class="py-name"><a title="pyxmpp.sasl" class="py-name" href="#" onclick="return doclink('link-10', 'sasl', 'link-1');">sasl</a></tt><tt class="py-op">.</tt><tt id="link-11" class="py-name" targets="Module pyxmpp.sasl.plain=pyxmpp.sasl.plain-module.html"><a title="pyxmpp.sasl.plain" class="py-name" href="#" onclick="return doclink('link-11', 'plain', 'link-11');">plain</a></tt> <tt class="py-keyword">import</tt> <tt id="link-12" class="py-name" targets="Class pyxmpp.sasl.plain.PlainClientAuthenticator=pyxmpp.sasl.plain.PlainClientAuthenticator-class.html"><a title="pyxmpp.sasl.plain.PlainClientAuthenticator" class="py-name" href="#" onclick="return doclink('link-12', 'PlainClientAuthenticator', 'link-12');">PlainClientAuthenticator</a></tt><tt class="py-op">,</tt><tt id="link-13" class="py-name" targets="Class pyxmpp.sasl.plain.PlainServerAuthenticator=pyxmpp.sasl.plain.PlainServerAuthenticator-class.html"><a title="pyxmpp.sasl.plain.PlainServerAuthenticator" class="py-name" href="#" onclick="return doclink('link-13', 'PlainServerAuthenticator', 'link-13');">PlainServerAuthenticator</a></tt> </tt>
<a name="L30"></a><tt class="py-lineno">30</tt>  <tt class="py-line"><tt class="py-keyword">from</tt> <tt id="link-14" class="py-name"><a title="pyxmpp" class="py-name" href="#" onclick="return doclink('link-14', 'pyxmpp', 'link-0');">pyxmpp</a></tt><tt class="py-op">.</tt><tt id="link-15" class="py-name"><a title="pyxmpp.sasl" class="py-name" href="#" onclick="return doclink('link-15', 'sasl', 'link-1');">sasl</a></tt><tt class="py-op">.</tt><tt id="link-16" class="py-name" targets="Module pyxmpp.sasl.digest_md5=pyxmpp.sasl.digest_md5-module.html"><a title="pyxmpp.sasl.digest_md5" class="py-name" href="#" onclick="return doclink('link-16', 'digest_md5', 'link-16');">digest_md5</a></tt> <tt class="py-keyword">import</tt> <tt id="link-17" class="py-name" targets="Class pyxmpp.sasl.digest_md5.DigestMD5ClientAuthenticator=pyxmpp.sasl.digest_md5.DigestMD5ClientAuthenticator-class.html"><a title="pyxmpp.sasl.digest_md5.DigestMD5ClientAuthenticator" class="py-name" href="#" onclick="return doclink('link-17', 'DigestMD5ClientAuthenticator', 'link-17');">DigestMD5ClientAuthenticator</a></tt><tt class="py-op">,</tt><tt id="link-18" class="py-name" targets="Class pyxmpp.sasl.digest_md5.DigestMD5ServerAuthenticator=pyxmpp.sasl.digest_md5.DigestMD5ServerAuthenticator-class.html"><a title="pyxmpp.sasl.digest_md5.DigestMD5ServerAuthenticator" class="py-name" href="#" onclick="return doclink('link-18', 'DigestMD5ServerAuthenticator', 'link-18');">DigestMD5ServerAuthenticator</a></tt> </tt>
<a name="L31"></a><tt class="py-lineno">31</tt>  <tt class="py-line"><tt class="py-keyword">from</tt> <tt id="link-19" class="py-name"><a title="pyxmpp" class="py-name" href="#" onclick="return doclink('link-19', 'pyxmpp', 'link-0');">pyxmpp</a></tt><tt class="py-op">.</tt><tt id="link-20" class="py-name"><a title="pyxmpp.sasl" class="py-name" href="#" onclick="return doclink('link-20', 'sasl', 'link-1');">sasl</a></tt><tt class="py-op">.</tt><tt id="link-21" class="py-name" targets="Module pyxmpp.sasl.external=pyxmpp.sasl.external-module.html"><a title="pyxmpp.sasl.external" class="py-name" href="#" onclick="return doclink('link-21', 'external', 'link-21');">external</a></tt> <tt class="py-keyword">import</tt> <tt id="link-22" class="py-name" targets="Class pyxmpp.sasl.external.ExternalClientAuthenticator=pyxmpp.sasl.external.ExternalClientAuthenticator-class.html"><a title="pyxmpp.sasl.external.ExternalClientAuthenticator" class="py-name" href="#" onclick="return doclink('link-22', 'ExternalClientAuthenticator', 'link-22');">ExternalClientAuthenticator</a></tt> </tt>
<a name="L32"></a><tt class="py-lineno">32</tt>  <tt class="py-line"> </tt>
<a name="L33"></a><tt class="py-lineno">33</tt>  <tt class="py-line"><tt id="link-23" class="py-name" targets="Variable pyxmpp.sasl.safe_mechanisms_dict=pyxmpp.sasl-module.html#safe_mechanisms_dict"><a title="pyxmpp.sasl.safe_mechanisms_dict" class="py-name" href="#" onclick="return doclink('link-23', 'safe_mechanisms_dict', 'link-23');">safe_mechanisms_dict</a></tt><tt class="py-op">=</tt><tt class="py-op">{</tt><tt class="py-string">"DIGEST-MD5"</tt><tt class="py-op">:</tt><tt class="py-op">(</tt><tt id="link-24" class="py-name"><a title="pyxmpp.sasl.digest_md5.DigestMD5ClientAuthenticator" class="py-name" href="#" onclick="return doclink('link-24', 'DigestMD5ClientAuthenticator', 'link-17');">DigestMD5ClientAuthenticator</a></tt><tt class="py-op">,</tt><tt id="link-25" class="py-name"><a title="pyxmpp.sasl.digest_md5.DigestMD5ServerAuthenticator" class="py-name" href="#" onclick="return doclink('link-25', 'DigestMD5ServerAuthenticator', 'link-18');">DigestMD5ServerAuthenticator</a></tt><tt class="py-op">)</tt><tt class="py-op">,</tt> </tt>
<a name="L34"></a><tt class="py-lineno">34</tt>  <tt class="py-line">                      <tt class="py-string">"EXTERNAL"</tt><tt class="py-op">:</tt><tt class="py-op">(</tt><tt id="link-26" class="py-name"><a title="pyxmpp.sasl.external.ExternalClientAuthenticator" class="py-name" href="#" onclick="return doclink('link-26', 'ExternalClientAuthenticator', 'link-22');">ExternalClientAuthenticator</a></tt><tt class="py-op">,</tt> <tt class="py-name">None</tt><tt class="py-op">)</tt><tt class="py-op">}</tt> </tt>
<a name="L35"></a><tt class="py-lineno">35</tt>  <tt class="py-line"><tt class="py-keyword">try</tt><tt class="py-op">:</tt> </tt>
<a name="L36"></a><tt class="py-lineno">36</tt>  <tt class="py-line">    <tt class="py-keyword">from</tt> <tt id="link-27" class="py-name"><a title="pyxmpp" class="py-name" href="#" onclick="return doclink('link-27', 'pyxmpp', 'link-0');">pyxmpp</a></tt><tt class="py-op">.</tt><tt id="link-28" class="py-name"><a title="pyxmpp.sasl" class="py-name" href="#" onclick="return doclink('link-28', 'sasl', 'link-1');">sasl</a></tt><tt class="py-op">.</tt><tt id="link-29" class="py-name" targets="Module pyxmpp.sasl.gssapi=pyxmpp.sasl.gssapi-module.html"><a title="pyxmpp.sasl.gssapi" class="py-name" href="#" onclick="return doclink('link-29', 'gssapi', 'link-29');">gssapi</a></tt> <tt class="py-keyword">import</tt> <tt id="link-30" class="py-name" targets="Class pyxmpp.sasl.gssapi.GSSAPIClientAuthenticator=pyxmpp.sasl.gssapi.GSSAPIClientAuthenticator-class.html"><a title="pyxmpp.sasl.gssapi.GSSAPIClientAuthenticator" class="py-name" href="#" onclick="return doclink('link-30', 'GSSAPIClientAuthenticator', 'link-30');">GSSAPIClientAuthenticator</a></tt> </tt>
<a name="L37"></a><tt class="py-lineno">37</tt>  <tt class="py-line"><tt class="py-keyword">except</tt> <tt class="py-name">ImportError</tt><tt class="py-op">:</tt> </tt>
<a name="L38"></a><tt class="py-lineno">38</tt>  <tt class="py-line">    <tt class="py-keyword">pass</tt> <tt class="py-comment"># Kerberos not available</tt> </tt>
<a name="L39"></a><tt class="py-lineno">39</tt>  <tt class="py-line"><tt class="py-keyword">else</tt><tt class="py-op">:</tt> </tt>
<a name="L40"></a><tt class="py-lineno">40</tt>  <tt class="py-line">    <tt id="link-31" class="py-name"><a title="pyxmpp.sasl.safe_mechanisms_dict" class="py-name" href="#" onclick="return doclink('link-31', 'safe_mechanisms_dict', 'link-23');">safe_mechanisms_dict</a></tt><tt class="py-op">[</tt><tt class="py-string">"GSSAPI"</tt><tt class="py-op">]</tt> <tt class="py-op">=</tt> <tt class="py-op">(</tt><tt id="link-32" class="py-name"><a title="pyxmpp.sasl.gssapi.GSSAPIClientAuthenticator" class="py-name" href="#" onclick="return doclink('link-32', 'GSSAPIClientAuthenticator', 'link-30');">GSSAPIClientAuthenticator</a></tt><tt class="py-op">,</tt><tt class="py-name">None</tt><tt class="py-op">)</tt> </tt>
<a name="L41"></a><tt class="py-lineno">41</tt>  <tt class="py-line"><tt id="link-33" class="py-name" targets="Variable pyxmpp.sasl.unsafe_mechanisms_dict=pyxmpp.sasl-module.html#unsafe_mechanisms_dict"><a title="pyxmpp.sasl.unsafe_mechanisms_dict" class="py-name" href="#" onclick="return doclink('link-33', 'unsafe_mechanisms_dict', 'link-33');">unsafe_mechanisms_dict</a></tt><tt class="py-op">=</tt><tt class="py-op">{</tt><tt class="py-string">"PLAIN"</tt><tt class="py-op">:</tt><tt class="py-op">(</tt><tt id="link-34" class="py-name"><a title="pyxmpp.sasl.plain.PlainClientAuthenticator" class="py-name" href="#" onclick="return doclink('link-34', 'PlainClientAuthenticator', 'link-12');">PlainClientAuthenticator</a></tt><tt class="py-op">,</tt><tt id="link-35" class="py-name"><a title="pyxmpp.sasl.plain.PlainServerAuthenticator" class="py-name" href="#" onclick="return doclink('link-35', 'PlainServerAuthenticator', 'link-13');">PlainServerAuthenticator</a></tt><tt class="py-op">)</tt><tt class="py-op">}</tt> </tt>
<a name="L42"></a><tt class="py-lineno">42</tt>  <tt class="py-line"><tt id="link-36" class="py-name" targets="Variable pyxmpp.sasl.all_mechanisms_dict=pyxmpp.sasl-module.html#all_mechanisms_dict"><a title="pyxmpp.sasl.all_mechanisms_dict" class="py-name" href="#" onclick="return doclink('link-36', 'all_mechanisms_dict', 'link-36');">all_mechanisms_dict</a></tt><tt class="py-op">=</tt><tt id="link-37" class="py-name"><a title="pyxmpp.sasl.safe_mechanisms_dict" class="py-name" href="#" onclick="return doclink('link-37', 'safe_mechanisms_dict', 'link-23');">safe_mechanisms_dict</a></tt><tt class="py-op">.</tt><tt id="link-38" class="py-name" targets="Method pyxmpp.iq.Iq.copy()=pyxmpp.iq.Iq-class.html#copy,Method pyxmpp.jabber.dataforms.Form.copy()=pyxmpp.jabber.dataforms.Form-class.html#copy,Method pyxmpp.jabber.muccore.MucIq.copy()=pyxmpp.jabber.muccore.MucIq-class.html#copy,Method pyxmpp.jabber.muccore.MucPresence.copy()=pyxmpp.jabber.muccore.MucPresence-class.html#copy,Method pyxmpp.message.Message.copy()=pyxmpp.message.Message-class.html#copy,Method pyxmpp.presence.Presence.copy()=pyxmpp.presence.Presence-class.html#copy,Method pyxmpp.stanza.Stanza.copy()=pyxmpp.stanza.Stanza-class.html#copy"><a title="pyxmpp.iq.Iq.copy
pyxmpp.jabber.dataforms.Form.copy
pyxmpp.jabber.muccore.MucIq.copy
pyxmpp.jabber.muccore.MucPresence.copy
pyxmpp.message.Message.copy
pyxmpp.presence.Presence.copy
pyxmpp.stanza.Stanza.copy" class="py-name" href="#" onclick="return doclink('link-38', 'copy', 'link-38');">copy</a></tt><tt class="py-op">(</tt><tt class="py-op">)</tt> </tt>
<a name="L43"></a><tt class="py-lineno">43</tt>  <tt class="py-line"><tt id="link-39" class="py-name"><a title="pyxmpp.sasl.all_mechanisms_dict" class="py-name" href="#" onclick="return doclink('link-39', 'all_mechanisms_dict', 'link-36');">all_mechanisms_dict</a></tt><tt class="py-op">.</tt><tt id="link-40" class="py-name" targets="Method pyxmpp.roster.Roster.update()=pyxmpp.roster.Roster-class.html#update"><a title="pyxmpp.roster.Roster.update" class="py-name" href="#" onclick="return doclink('link-40', 'update', 'link-40');">update</a></tt><tt class="py-op">(</tt><tt id="link-41" class="py-name"><a title="pyxmpp.sasl.unsafe_mechanisms_dict" class="py-name" href="#" onclick="return doclink('link-41', 'unsafe_mechanisms_dict', 'link-33');">unsafe_mechanisms_dict</a></tt><tt class="py-op">)</tt> </tt>
<a name="L44"></a><tt class="py-lineno">44</tt>  <tt class="py-line"> </tt>
<a name="L45"></a><tt class="py-lineno">45</tt>  <tt class="py-line"><tt id="link-42" class="py-name" targets="Variable pyxmpp.sasl.safe_mechanisms=pyxmpp.sasl-module.html#safe_mechanisms"><a title="pyxmpp.sasl.safe_mechanisms" class="py-name" href="#" onclick="return doclink('link-42', 'safe_mechanisms', 'link-42');">safe_mechanisms</a></tt><tt class="py-op">=</tt><tt id="link-43" class="py-name"><a title="pyxmpp.sasl.safe_mechanisms_dict" class="py-name" href="#" onclick="return doclink('link-43', 'safe_mechanisms_dict', 'link-23');">safe_mechanisms_dict</a></tt><tt class="py-op">.</tt><tt class="py-name">keys</tt><tt class="py-op">(</tt><tt class="py-op">)</tt> </tt>
<a name="L46"></a><tt class="py-lineno">46</tt>  <tt class="py-line"><tt id="link-44" class="py-name" targets="Variable pyxmpp.sasl.unsafe_mechanisms=pyxmpp.sasl-module.html#unsafe_mechanisms"><a title="pyxmpp.sasl.unsafe_mechanisms" class="py-name" href="#" onclick="return doclink('link-44', 'unsafe_mechanisms', 'link-44');">unsafe_mechanisms</a></tt><tt class="py-op">=</tt><tt id="link-45" class="py-name"><a title="pyxmpp.sasl.unsafe_mechanisms_dict" class="py-name" href="#" onclick="return doclink('link-45', 'unsafe_mechanisms_dict', 'link-33');">unsafe_mechanisms_dict</a></tt><tt class="py-op">.</tt><tt class="py-name">keys</tt><tt class="py-op">(</tt><tt class="py-op">)</tt> </tt>
<a name="L47"></a><tt class="py-lineno">47</tt>  <tt class="py-line"><tt id="link-46" class="py-name" targets="Variable pyxmpp.sasl.all_mechanisms=pyxmpp.sasl-module.html#all_mechanisms"><a title="pyxmpp.sasl.all_mechanisms" class="py-name" href="#" onclick="return doclink('link-46', 'all_mechanisms', 'link-46');">all_mechanisms</a></tt><tt class="py-op">=</tt><tt id="link-47" class="py-name"><a title="pyxmpp.sasl.safe_mechanisms" class="py-name" href="#" onclick="return doclink('link-47', 'safe_mechanisms', 'link-42');">safe_mechanisms</a></tt><tt class="py-op">+</tt><tt id="link-48" class="py-name"><a title="pyxmpp.sasl.unsafe_mechanisms" class="py-name" href="#" onclick="return doclink('link-48', 'unsafe_mechanisms', 'link-44');">unsafe_mechanisms</a></tt> </tt>
<a name="L48"></a><tt class="py-lineno">48</tt>  <tt class="py-line"> </tt>
<a name="client_authenticator_factory"></a><div id="client_authenticator_factory-def"><a name="L49"></a><tt class="py-lineno">49</tt> <a class="py-toggle" href="#" id="client_authenticator_factory-toggle" onclick="return toggle('client_authenticator_factory');">-</a><tt class="py-line"><tt class="py-keyword">def</tt> <a class="py-def-name" href="pyxmpp.sasl-module.html#client_authenticator_factory">client_authenticator_factory</a><tt class="py-op">(</tt><tt class="py-param">mechanism</tt><tt class="py-op">,</tt><tt class="py-param">password_manager</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="client_authenticator_factory-collapsed" style="display:none;" pad="++" indent="++++"></div><div id="client_authenticator_factory-expanded"><a name="L50"></a><tt class="py-lineno">50</tt>  <tt class="py-line">    <tt class="py-docstring">"""Create a client authenticator object for given SASL mechanism and</tt> </tt>
<a name="L51"></a><tt class="py-lineno">51</tt>  <tt class="py-line"><tt class="py-docstring">    password manager.</tt> </tt>
<a name="L52"></a><tt class="py-lineno">52</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L53"></a><tt class="py-lineno">53</tt>  <tt class="py-line"><tt class="py-docstring">    :Parameters:</tt> </tt>
<a name="L54"></a><tt class="py-lineno">54</tt>  <tt class="py-line"><tt class="py-docstring">        - `mechanism`: name of the SASL mechanism ("PLAIN", "DIGEST-MD5" or "GSSAPI").</tt> </tt>
<a name="L55"></a><tt class="py-lineno">55</tt>  <tt class="py-line"><tt class="py-docstring">        - `password_manager`: name of the password manager object providing</tt> </tt>
<a name="L56"></a><tt class="py-lineno">56</tt>  <tt class="py-line"><tt class="py-docstring">          authentication credentials.</tt> </tt>
<a name="L57"></a><tt class="py-lineno">57</tt>  <tt class="py-line"><tt class="py-docstring">    :Types:</tt> </tt>
<a name="L58"></a><tt class="py-lineno">58</tt>  <tt class="py-line"><tt class="py-docstring">        - `mechanism`: `str`</tt> </tt>
<a name="L59"></a><tt class="py-lineno">59</tt>  <tt class="py-line"><tt class="py-docstring">        - `password_manager`: `PasswordManager`</tt> </tt>
<a name="L60"></a><tt class="py-lineno">60</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L61"></a><tt class="py-lineno">61</tt>  <tt class="py-line"><tt class="py-docstring">    :return: new authenticator.</tt> </tt>
<a name="L62"></a><tt class="py-lineno">62</tt>  <tt class="py-line"><tt class="py-docstring">    :returntype: `sasl.core.ClientAuthenticator`"""</tt> </tt>
<a name="L63"></a><tt class="py-lineno">63</tt>  <tt class="py-line">    <tt class="py-name">authenticator</tt><tt class="py-op">=</tt><tt id="link-49" class="py-name"><a title="pyxmpp.sasl.all_mechanisms_dict" class="py-name" href="#" onclick="return doclink('link-49', 'all_mechanisms_dict', 'link-36');">all_mechanisms_dict</a></tt><tt class="py-op">[</tt><tt class="py-name">mechanism</tt><tt class="py-op">]</tt><tt class="py-op">[</tt><tt class="py-number">0</tt><tt class="py-op">]</tt> </tt>
<a name="L64"></a><tt class="py-lineno">64</tt>  <tt class="py-line">    <tt class="py-keyword">return</tt> <tt class="py-name">authenticator</tt><tt class="py-op">(</tt><tt class="py-name">password_manager</tt><tt class="py-op">)</tt> </tt>
</div><a name="L65"></a><tt class="py-lineno">65</tt>  <tt class="py-line"> </tt>
<a name="server_authenticator_factory"></a><div id="server_authenticator_factory-def"><a name="L66"></a><tt class="py-lineno">66</tt> <a class="py-toggle" href="#" id="server_authenticator_factory-toggle" onclick="return toggle('server_authenticator_factory');">-</a><tt class="py-line"><tt class="py-keyword">def</tt> <a class="py-def-name" href="pyxmpp.sasl-module.html#server_authenticator_factory">server_authenticator_factory</a><tt class="py-op">(</tt><tt class="py-param">mechanism</tt><tt class="py-op">,</tt><tt class="py-param">password_manager</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="server_authenticator_factory-collapsed" style="display:none;" pad="++" indent="++++"></div><div id="server_authenticator_factory-expanded"><a name="L67"></a><tt class="py-lineno">67</tt>  <tt class="py-line">    <tt class="py-docstring">"""Create a server authenticator object for given SASL mechanism and</tt> </tt>
<a name="L68"></a><tt class="py-lineno">68</tt>  <tt class="py-line"><tt class="py-docstring">    password manager.</tt> </tt>
<a name="L69"></a><tt class="py-lineno">69</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L70"></a><tt class="py-lineno">70</tt>  <tt class="py-line"><tt class="py-docstring">    :Parameters:</tt> </tt>
<a name="L71"></a><tt class="py-lineno">71</tt>  <tt class="py-line"><tt class="py-docstring">        - `mechanism`: name of the SASL mechanism ("PLAIN", "DIGEST-MD5" or "GSSAPI").</tt> </tt>
<a name="L72"></a><tt class="py-lineno">72</tt>  <tt class="py-line"><tt class="py-docstring">        - `password_manager`: name of the password manager object to be used</tt> </tt>
<a name="L73"></a><tt class="py-lineno">73</tt>  <tt class="py-line"><tt class="py-docstring">          for authentication credentials verification.</tt> </tt>
<a name="L74"></a><tt class="py-lineno">74</tt>  <tt class="py-line"><tt class="py-docstring">    :Types:</tt> </tt>
<a name="L75"></a><tt class="py-lineno">75</tt>  <tt class="py-line"><tt class="py-docstring">        - `mechanism`: `str`</tt> </tt>
<a name="L76"></a><tt class="py-lineno">76</tt>  <tt class="py-line"><tt class="py-docstring">        - `password_manager`: `PasswordManager`</tt> </tt>
<a name="L77"></a><tt class="py-lineno">77</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L78"></a><tt class="py-lineno">78</tt>  <tt class="py-line"><tt class="py-docstring">    :return: new authenticator.</tt> </tt>
<a name="L79"></a><tt class="py-lineno">79</tt>  <tt class="py-line"><tt class="py-docstring">    :returntype: `sasl.core.ServerAuthenticator`"""</tt> </tt>
<a name="L80"></a><tt class="py-lineno">80</tt>  <tt class="py-line">    <tt class="py-name">authenticator</tt><tt class="py-op">=</tt><tt id="link-50" class="py-name"><a title="pyxmpp.sasl.all_mechanisms_dict" class="py-name" href="#" onclick="return doclink('link-50', 'all_mechanisms_dict', 'link-36');">all_mechanisms_dict</a></tt><tt class="py-op">[</tt><tt class="py-name">mechanism</tt><tt class="py-op">]</tt><tt class="py-op">[</tt><tt class="py-number">1</tt><tt class="py-op">]</tt> </tt>
<a name="L81"></a><tt class="py-lineno">81</tt>  <tt class="py-line">    <tt class="py-keyword">return</tt> <tt class="py-name">authenticator</tt><tt class="py-op">(</tt><tt class="py-name">password_manager</tt><tt class="py-op">)</tt> </tt>
</div><a name="L82"></a><tt class="py-lineno">82</tt>  <tt class="py-line"> </tt>
<a name="L83"></a><tt class="py-lineno">83</tt>  <tt class="py-line"><tt class="py-comment"># vi: sts=4 et sw=4</tt> </tt>
<a name="L84"></a><tt class="py-lineno">84</tt>  <tt class="py-line"> </tt><script type="text/javascript">
<!--
expandto(location.href);
// -->
</script>
</pre>
<br />
<!-- ==================== NAVIGATION BAR ==================== -->
<table class="navbar" border="0" width="100%" cellpadding="0"
       bgcolor="#a0c0ff" cellspacing="0">
  <tr valign="middle">
  <!-- Home link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="pyxmpp-module.html">Home</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Tree link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="module-tree.html">Trees</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Index link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="identifier-index.html">Indices</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Help link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="help.html">Help</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Project homepage -->
      <th class="navbar" align="right" width="100%">
        <table border="0" cellpadding="0" cellspacing="0">
          <tr><th class="navbar" align="center"
            ><a class="navbar" target="_top" href="http://pyxmpp.jajcus.net/">PyXMPP</a></th>
          </tr></table></th>
  </tr>
</table>
<table border="0" cellpadding="0" cellspacing="0" width="100%%">
  <tr>
    <td align="left" class="footer">
    Generated by Epydoc 3.0.1 on Sun May  8 13:35:08 2011
    </td>
    <td align="right" class="footer">
      <a target="mainFrame" href="http://epydoc.sourceforge.net"
        >http://epydoc.sourceforge.net</a>
    </td>
  </tr>
</table>

<script type="text/javascript">
  <!--
  // Private objects are initially displayed (because if
  // javascript is turned off then we want them to be
  // visible); but by default, we want to hide them.  So hide
  // them unless we have a cookie that says to show them.
  checkCookie();
  // -->
</script>
</body>
</html>
